package jlx.asal.j;

import java.util.*;

public class JPort extends JType {
	private Set<JPort> connectedPorts;
	
	public JPort() {
		connectedPorts = new HashSet<JPort>();
	}
	
	public void disconnectAll() {
		connectedPorts.clear();
	}
	
	protected final void addSourcePort(JPort sourcePort) {
		if (sourcePort == null) {
			throw new Error("Source port should NOT be null!");
		}
		
		sourcePort.connectedPorts.add(this);
		connectedPorts.add(sourcePort);
	}
	
	protected final void addTargetPort(JPort targetPort) {
		if (targetPort == null) {
			throw new Error("Target port should NOT be null!");
		}
		
		targetPort.connectedPorts.add(this);
		connectedPorts.add(targetPort);
	}
	
	public Set<JPort> getConnectedPorts() {
		return Collections.unmodifiableSet(connectedPorts);
	}
}
