package jlx.asal.j;

public class JStat extends JType {
	@JTypeTextify(format = "")
	public final static class EMPTY extends JStat {}
	
	@JTypeExpr
	@JTypeTextify(format = "#target _ := _ #expr ;")
	public final static class ASSIGNMENT extends JStat {
		public JType target;
		public JType expr;
		
		public ASSIGNMENT() {
			//Empty.
		}
		
		public ASSIGNMENT(JType target, JType expr) {
			this.target = target;
			this.expr = expr;
		}
	}
	
	@JTypeExpr
	@JTypeTextify(format = "#invocationExpr ;")
	public final static class INVOKE extends JStat {
		public JType invocationExpr;
		
		public INVOKE() {
			//Empty.
		}
		
		public INVOKE(JType invocationExpr) {
			this.invocationExpr = invocationExpr;
		}
	}
	
	@JTypeExpr
	@JTypeTextify(format = "if _ ( #condition ) _ then _ #thenBranch _ else _ #elseBranch _ end _ if")
	public final static class IF extends JStat {
		public JBool condition;
		public JStat thenBranch;
		public JStat elseBranch;
		
		public IF() {
			//Empty.
		}
		
		public IF(JBool condition, JStat thenBranch, JStat elseBranch) {
			this.condition = condition;
			this.thenBranch = thenBranch;
			this.elseBranch = elseBranch;
		}
	}
	
	@JTypeExpr
	@JTypeTextify(format = "return ;")
	public final static class RETURN_VOID extends JStat {
		public RETURN_VOID() {
			//Empty.
		}
	}
	
	@JTypeExpr
	@JTypeTextify(format = "return _ #expr ;")
	public final static class RETURN extends JStat {
		public JType expr;
		
		public RETURN() {
			//Empty.
		}
		
		public RETURN(JType expr) {
			this.expr = expr;
		}
	}
	
	@JTypeExpr
	@JTypeTextify(format = "#statement _ #successor")
	public final static class SEQ extends JStat {
		public JStat statement;
		public JStat successor;
		
		public SEQ() {
			//Empty.
		}
		
		public SEQ(JStat statement, JStat successor) {
			this.statement = statement;
			this.successor = successor;
		}
	}
	
	@JTypeExpr
	@JTypeTextify(format = "while _ ( #condition ) _ #body _ end _ while")
	public final static class WHILE extends JStat {
		public JBool condition;
		public JStat body;
		
		public WHILE() {
			//Empty.
		}
		
		public WHILE(JBool condition, JStat body) {
			this.condition = condition;
			this.body = body;
		}
	}
	
	public static JStat seq(JStat stat0, JStat... statements) {
		JStat result = stat0;
		
		for (int index = 0; index < statements.length; index++) {
			result = new JStat.SEQ(result, statements[index]);
		}
		
		return result;
	}
}
