package jlx.asal.j;

public class JTrigger extends JType {
	@JTypeExpr
	@JTypeTextify(format = "Entry _ / _ #stat")
	public final static class ENTRY extends JTrigger {
		public JStat stat;
		
		public ENTRY(JStat stat) {
			this.stat = stat;
		}
	}
	
	@JTypeExpr
	@JTypeTextify(format = "Exit _ / _ #stat")
	public final static class EXIT extends JTrigger {
		public JStat stat;
		
		public EXIT(JStat stat) {
			this.stat = stat;
		}
	}
	
	@JTypeExpr
	@JTypeTextify(format = "finalized _ / _ #stat")
	public final static class FINALIZED extends JTrigger {
		public JStat stat;
		
		public FINALIZED(JStat stat) {
			this.stat = stat;
		}
	}
	
	@JTypeExpr
	@JTypeTextify(format = "[ #guard ] _ / _ #stat")
	public final static class NONE extends JTrigger {
		public JBool guard;
		public JStat stat;
		
//		public NONE() {
//			//Empty.
//		}
		
		public NONE(JBool guard, JStat stat) {
			this.guard = guard;
			this.stat = stat;
		}
	}
	
	@JTypeExpr
	@JTypeTextify(format = "after( #timeout ) _ [ #guard ] _ / _ #stat")
	public final static class AFTER extends JTrigger {
		public JType timeout;
		public JBool guard;
		public JStat stat;
		
		public AFTER() {
			//Empty.
		}
		
		public AFTER(JType timeout, JBool guard, JStat stat) {
			this.timeout = timeout;
			this.guard = guard;
			this.stat = stat;
		}
	}
	
	@JTypeExpr
	@JTypeTextify(format = "when( #predicate ) _ [ #guard ] _ / _ #stat")
	public final static class WHEN extends JTrigger {
		public JType predicate;
		public JBool guard;
		public JStat stat;
		
		public WHEN() {
			//Empty.
		}
		
		public WHEN(JType predicate, JBool guard, JStat stat) {
			this.predicate = predicate;
			this.guard = guard;
			this.stat = stat;
		}
	}
}
