package jlx.asal.vars;

import java.lang.reflect.Field;

import jlx.asal.j.*;
import jlx.asal.ops.ASALOperation;
import jlx.blocks.ibd1.Type1IBD;
import jlx.common.FileLocation;
import jlx.common.reflection.ReflectionException;

public class ASALParam implements ASALVariable {
	private final ASALOperation operation;
	private final JType param;
	private final boolean isWritable;
	
	public ASALParam(ASALOperation operation, JType param) throws ReflectionException {
		this.operation = operation;
		this.param = param;
		
		isWritable = true;
	}
	
	@Override
	public FileLocation getFileLocation() {
		return operation.getFileLocation();
	}
	
//	@Override
//	public String textify(TextOptions lod, String i) {
//		return lod.id(name) + "::" + typeInstance.getClass().getSimpleName();
//	}
	
	@Override
	public JType getLegacy() {
		return param;
	}
	
	@Override
	public String getName() {
		return param.getParamName();
	}
	
	@Override
	public Class<? extends JType> getType() {
		return param.getClass();
	}
	
	@Override
	public ASALVarOrigin getOrigin() {
		return ASALVarOrigin.FCT_PARAM;
	}
	
	@Override
	public Field getField() {
		return operation.getField();
	}
	
	@Override
	public boolean isWritable() {
		return isWritable;
	}
	
	@Override
	public Type1IBD getOwner() {
		return operation.getOwner();
	}
	
	@Override
	public JType getInitialValue() {
		return null; //(unused... more convenient than checking if ASALVariable is an ASALParam...)
	}
	
	@Override
	public void setInitialValue(JType newValue) {
		//(unused... more convenient than checking if ASALVariable is an ASALParam...)
	}
}
