package jlx.behave;

import jlx.asal.j.*;
import jlx.asal.parsing.ASALCode;

public class Entry extends CodeObject {
	public Entry(String code0, String... code) {
		super(new ASALCode("TRANSITION", "Entry / " + code0, code));
	}
	
	public Entry(JStat stat0, JStat... stats) {
		super(new ASALCode("TRANSITION", new JTrigger.ENTRY(prepend(stat0, stats))));
	}
	
	private static JStat prepend(JStat stat0, JStat... stats) {
		if (stats.length == 0) {
			return stat0;
		}
		
		JStat result = stat0;
		
		for (int index = 0; index < stats.length; index++) {
			result = new JStat.SEQ(result, stats[index]);
		}
		
		return result;
	}
}
