package jlx.behave.proto;

import java.util.*;

public class DecaFourCfgPair {
	private final DecaFourStateConfig src;
	private final DecaFourStateConfig tgt;
	private final PulsePackMap inputVal;
	private final int hashCode;
	
	public DecaFourCfgPair(DecaFourStateConfig src, DecaFourStateConfig tgt, PulsePackMap inputVal) {
		this.src = src;
		this.tgt = tgt;
		this.inputVal = inputVal;
		
		hashCode = extractHashCode();
	}
	
	private int extractHashCode() {
		return Objects.hash(inputVal, src, tgt);
	}
	
	public DecaFourStateConfig getSrc() {
		return src;
	}
	
	public DecaFourStateConfig getTgt() {
		return tgt;
	}
	
	public PulsePackMap getInputVal() {
		return inputVal;
	}
	
	@Override
	public int hashCode() {
		return hashCode;
	}
	
	@Override
	public boolean equals(Object obj) {
		if (this == obj)
			return true;
		if (obj == null)
			return false;
		if (getClass() != obj.getClass())
			return false;
		DecaFourCfgPair other = (DecaFourCfgPair) obj;
		return Objects.equals(inputVal, other.inputVal) && Objects.equals(src, other.src) && Objects.equals(tgt, other.tgt);
	}
	
	@Override
	public String toString() {
		return src.toString() + " ==> " + tgt.toString();
	}
}
