package jlx.behave.proto;

import java.util.*;

public class DecaFourCoverageStats {
	private String name;
	private final Set<DecaFourTransition> transitions4;
	
	public DecaFourCoverageStats() {
		name = "unnamed-coverage-stats";
		transitions4 = new HashSet<DecaFourTransition>();
	}
	
	public DecaFourCoverageStats(DecaFourCoverageStats source) {
		name = "unnamed-coverage-stats";
		transitions4 = new HashSet<DecaFourTransition>(source.transitions4);
	}
	
	public void setName(String name) {
		this.name = name;
	}
	
	public String getName() {
		return name;
	}
	
	public Set<DecaFourTransition> getTransitions4() {
		return Collections.unmodifiableSet(transitions4);
	}
	
	public void clear() {
		transitions4.clear();
	}
	
	public void add4(Set<DecaFourTransition> trs) {
		transitions4.addAll(trs);
	}
	
	public void addAll(DecaFourCoverageStats other) {
		transitions4.addAll(other.transitions4);
	}
	
	public Set<DecaFourVertex> getVertices4() {
		Set<DecaFourVertex> result = new HashSet<DecaFourVertex>();
		
		for (DecaFourTransition t : transitions4) {
			result.addAll(t.getVertices());
		}
		
		return result;
	}
	
	public <T extends LineageObject> Set<T> aggregateLineageObjects(Class<T> filter) {
		Set<T> result = new HashSet<T>();
		
		for (DecaFourTransition t : transitions4) {
			for (LineageObject x : t.aggregateLineageObjects()) {
				if (filter.isAssignableFrom(x.getClass())) {
					result.add(filter.cast(x));
				}
			}
		}
		
		return result;
	}
	
	@Override
	public int hashCode() {
		return Objects.hash(transitions4);
	}
	
	@Override
	public boolean equals(Object obj) {
		if (this == obj)
			return true;
		if (obj == null)
			return false;
		if (getClass() != obj.getClass())
			return false;
		DecaFourCoverageStats other = (DecaFourCoverageStats) obj;
		return Objects.equals(transitions4, other.transitions4);
	}
	
	@Override
	public String toString() {
		return Integer.toString(transitions4.size());
	}
}

