package jlx.behave.proto;

import java.util.*;

import jlx.models.UnifyingBlock.ReprPort;
import jlx.utils.ldd.*;

public class DecaFourPulsePackMaps {
	private final LDD<ReprPort, PulsePack> ldd;
	private final PulsePackMap someMap;
	
	public DecaFourPulsePackMaps(Set<PulsePackMap> maps, LDDEncoding<ReprPort, PulsePack> externalInputValEncoding) {
		Set<Map<ReprPort, PulsePack>> ys = new HashSet<Map<ReprPort, PulsePack>>();
		
		for (PulsePackMap map : maps) {
			PulsePackMap externalMap = map.extractExternalMap();
			int externalPulseCount = externalMap.getTruePulseCount();
			
			if (externalPulseCount == 0 || externalPulseCount == 1) {
				ys.add(externalMap.getPackPerPort());
			}
		}
		
		ldd = new LDD<ReprPort, PulsePack>(ys, externalInputValEncoding);
		someMap = maps.iterator().next();
	}
	
	public PulsePackMap getSomeMap() {
		return someMap;
	}
	
	public int getMapCount() {
		return ldd.size();
	}
	
	public LDD<ReprPort, PulsePack> getLDD() {
		return ldd;
	}
}

