package jlx.behave.proto;

import java.util.*;

import jlx.common.FileLocation;

public class DecaOneVertex implements LineageObject {
	private final DecaVertex legacy;
	private final Set<String> names;
	private final String name;
	
	public DecaOneVertex(DecaVertex source) {
		legacy = source;
		names = new TreeSet<String>();
		name = source.toString();
	}
	
	public Set<String> getNames() {
		return names;
	}
	
	public Set<Class<?>> getSysmlClzs() {
		return legacy.getSysmlClzs();
	}
	
	public Set<FileLocation> getFileLocations() {
		return legacy.getFileLocations();
	}
	
	public DecaVertex getLegacy() {
		return legacy;
	}
	
	@Override
	public Set<LineageObject> getImpliedElements() {
		return Collections.singleton(legacy);
	}
	
	@Override
	public Set<LineageObject> getInferredElements() {
		return Collections.emptySet();
	}
	
	@Override
	public String toString() {
		return name;
	}
}
