package jlx.behave.proto;

import java.util.*;

import jlx.asal.rewrite.ASALSymbolicValue;
import jlx.asal.vars.ASALVariable;
import jlx.common.FileLocation;
import jlx.models.UnifyingBlock.ReprPort;

public class DecaTritoVertex implements LineageObject {
	private final DecaTwoVertex legacy;
	private final Set<DecaTritoTransition> outgoing;
	private final Map<ReprPort, ASALSymbolicValue> outputVal;
	private final String name;
	
	public DecaTritoVertex(DecaTwoVertex legacy) {
		this.legacy = legacy;
		
		outgoing = new HashSet<DecaTritoTransition>();
		
		Map<ReprPort, ASALSymbolicValue> m = new HashMap<ReprPort, ASALSymbolicValue>();
		
		for (Map.Entry<ASALVariable, ASALSymbolicValue> e : legacy.getStateConfig().getValuation().entrySet()) {
			if (e.getKey() instanceof ReprPort) {
				m.put((ReprPort)e.getKey(), e.getValue());
			}
		}
		
		outputVal = m;
		name = legacy.toString();
	}
	
	public DecaTwoVertex getLegacy() {
		return legacy;
	}
	
	public Set<DecaTritoTransition> getOutgoing() {
		return outgoing;
	}
	
	public Map<ReprPort, ASALSymbolicValue> getOutputVal() {
		return outputVal;
	}
	
	public Set<Class<?>> getSysmlClzs() {
		return legacy.getStateConfig().getSysmlClzs();
	}
	
	public Set<FileLocation> getFileLocations() {
		return legacy.getStateConfig().getFileLocations();
	}
	
	@Override
	public Set<LineageObject> getImpliedElements() {
		return Collections.singleton(legacy);
	}
	
	@Override
	public Set<LineageObject> getInferredElements() {
		return Collections.emptySet();
	}
	
	public String getName() {
		return name;
	}
	
//	public int getId() {
//		return legacy.getId();
//	}
	
	@Override
	public String toString() {
		return name;
	}
}
