package jlx.behave.proto;

import java.util.*;

public class DecaTwoVertex implements LineageObject {
	private final DecaTwoStateConfig stateConfig;
	private final Set<DecaTwoTransition> outgoing;
	
	private String name;
	
	public DecaTwoVertex(DecaTwoStateConfig stateConfig) {
		this.stateConfig = stateConfig;
		
		outgoing = new HashSet<DecaTwoTransition>();
	}
	
	public DecaTwoStateConfig getStateConfig() {
		return stateConfig;
	}
	
	public Set<Class<?>> getSysmlClzs() {
		return stateConfig.getSysmlClzs();
	}
	
	public Set<DecaTwoTransition> getOutgoing() {
		return outgoing;
	}
	
	public void initName(String name) {
		if (this.name != null) {
			throw new Error("Cannot set again!");
		}
		
		if (name == null) {
			throw new Error("Cannot set to null!");
		}
		
		this.name = name;
	}
	
	public String getName() {
		return name;
	}
	
	@Override
	public String toString() {
		return name;
	}
	
	@Override
	public Set<LineageObject> getImpliedElements() {
		return Collections.singleton(stateConfig.getVertex());
	}
	
	@Override
	public Set<LineageObject> getInferredElements() {
		return Collections.emptySet();
	}
}
