package jlx.behave.proto;

import java.util.*;

import jlx.common.FileLocation;

public class HexaVertex implements LineageObject {
	private final PentaVertex legacy;
	private final String name;
	
	public HexaVertex(PentaVertex source) {
		legacy = source;
		name = source.toString();
	}
	
	public Class<?> getSysmlClz() {
		return legacy.getSysmlClz();
	}
	
	public FileLocation getFileLocation() {
		return legacy.getFileLocation();
	}
	
	public PentaVertex getLegacy() {
		return legacy;
	}
	
	@Override
	public Set<LineageObject> getImpliedElements() {
		return Collections.singleton(legacy);
	}
	
	@Override
	public Set<LineageObject> getInferredElements() {
		return Collections.emptySet();
	}
	
	@Override
	public String toString() {
		return name;
	}
}
