package jlx.behave.proto;

import java.util.*;

public interface LineageObject {
	/**
	 * Transient object = Object (part of this entity) that is guaranteed to also be part of a descendant entity.
	 */
	public Set<LineageObject> getImpliedElements();
	public Set<LineageObject> getInferredElements();
	
	public default Set<LineageObject> aggregateLineageObjects() {
		Set<LineageObject> result = new HashSet<LineageObject>();
		
		Set<LineageObject> fringe = new HashSet<LineageObject>();
		Set<LineageObject> newFringe = new HashSet<LineageObject>();
		fringe.addAll(getInferredElements());
		fringe.add(this);
		
		while (fringe.size() > 0) {
			newFringe.clear();
			
			for (LineageObject f : fringe) {
				for (LineageObject x : f.getImpliedElements()) {
					if (result.add(x)) {
						newFringe.add(x);
					}
				}
			}
			
			fringe.clear();
			fringe.addAll(newFringe);
		}
		
		return result;
	}
}
