package jlx.behave.proto;

import java.util.*;

import jlx.common.FileLocation;

public class NonaVertex implements LineageObject {
	private final OctoVertex legacy;
	private final String name;
	
	public NonaVertex(OctoVertex source) {
		legacy = source;
		name = source.toString();
	}
	
	public Set<Class<?>> getSysmlClzs() {
		return legacy.getSysmlClzs();
	}
	
	public Set<FileLocation> getFileLocations() {
		return legacy.getFileLocations();
	}
	
	public OctoVertex getLegacy() {
		return legacy;
	}
	
	@Override
	public Set<LineageObject> getImpliedElements() {
		return Collections.singleton(legacy);
	}
	
	@Override
	public Set<LineageObject> getInferredElements() {
		return Collections.emptySet();
	}
	
	@Override
	public String toString() {
		return name;
	}
}
