package jlx.behave.proto;

import java.util.*;

import jlx.common.FileLocation;
import jlx.utils.Texts;

public class OctoVertex implements LineageObject {
	private final OctoStateConfig stateConfig;
	private final String name;
	
	public OctoVertex(OctoStateConfig stateConfig) {
		this.stateConfig = stateConfig;
		
		name = Texts.concat(stateConfig.states, "+");
	}
	
	public Set<Class<?>> getSysmlClzs() {
		Set<Class<?>> result = new HashSet<Class<?>>();
		
		for (SeptaVertex v : stateConfig.states) {
			result.add(v.getSysmlClz());
		}
		
		return result;
	}
	
	public Set<FileLocation> getFileLocations() {
		Set<FileLocation> result = new HashSet<FileLocation>();
		
		for (SeptaVertex v : stateConfig.states) {
			result.add(v.getFileLocation());
		}
		
		return result;
	}
	
	public OctoStateConfig getStateConfig() {
		return stateConfig;
	}
	
	@Override
	public Set<LineageObject> getImpliedElements() {
		Set<LineageObject> result = new HashSet<LineageObject>();
		result.addAll(stateConfig.states);
		return result;
	}
	
	@Override
	public Set<LineageObject> getInferredElements() {
		return Collections.emptySet();
	}
	
	@Override
	public String toString() {
		return name;
	}
}
