package jlx.behave.proto;

import java.util.*;

import jlx.common.FileLocation;

public class TetraVertex implements LineageObject {
	private final TritoVertex legacy;
	private final String name;
	
	public TetraVertex(TritoVertex source) {
		legacy = source;
		name = legacy.toString();
	}
	
	public Class<?> getSysmlClz() {
		return legacy.getSysmlClz();
	}
	
	public boolean isSimpleOrFinal() {
		return legacy.isSimpleOrFinal();
	}
	
	public FileLocation getFileLocation() {
		return legacy.getFileLocation();
	}
	
	public TritoVertex getLegacy() {
		return legacy;
	}
	
	@Override
	public Set<LineageObject> getImpliedElements() {
		return Collections.singleton(legacy);
	}
	
	@Override
	public Set<LineageObject> getInferredElements() {
		return Collections.emptySet();
	}
	
	@Override
	public String toString() {
		return name;
	}
}
