package jlx.behave.stable.files;

public enum DecaStableFileContent {
	//Order is required for object resolution:
	SCOPES("scopes"),
	INPUT_PORTS("inputports"),
	OUTPUT_PORTS("outputports"),
	VERTICES("vertices"),
	INPUT_CHANGES("inputchanges"),
	OUTPUT_EVOS("outputevos"),
	TRANSITIONS("transitions"),
	
	//~Independent in order:
	CHARSETS("charsets"),
	TESTS("tests"),
	TEST_SUITES("testsuites"),
	PROTO("proto"),
	
	;
	
	private final String id;
	
	private DecaStableFileContent(String id) {
		this.id = id;
	}
	
	public String getId() {
		return id;
	}
	
	public static DecaStableFileContent resolve(String id) {
		for (DecaStableFileContent value : values()) {
			if (value.getId().equals(id)) {
				return value;
			}
		}
		
		throw new Error("Should not happen!");
	}
}
