package jlx.scenario;

import java.util.HashMap;
import java.util.Map;

import jlx.asal.j.*;
import jlx.blocks.ibd1.OutPort;

public class Output {
	private Map<OutPort<?>, JType> valuePerPort;
	
	public Output(Map<OutPort<?>, JType> valuePerPort) {
		this.valuePerPort = valuePerPort;
	}
	
	public Map<OutPort<?>, JType> getValuePerPort() {
		return valuePerPort;
	}
	
	private static Output from(OutPort<?>[] ports, JType[] expectedValues) {
		Map<OutPort<?>, JType> valuePerPort = new HashMap<OutPort<?>, JType>();
		
		for (int index = 0; index < ports.length; index++) {
			valuePerPort.put(ports[index], expectedValues[index]);
		}
		
		return new Output(valuePerPort);
	}
	
	public static <T extends JType> Output from(OutPort<T> port, T expectedValue) {
		return from(new OutPort<?>[] { port }, new JType[] { expectedValue });
	}
	
	public static <T1 extends JType, T2 extends JType> Output from(OutPort<T1> port1, T1 expectedValue1, OutPort<T2> port2, T2 expectedValue2) {
		return from(new OutPort<?>[] { port1, port2 }, new JType[] { expectedValue1, expectedValue2 });
	}
	
	public static <T1 extends JType, T2 extends JType, T3 extends JType> Output from(OutPort<T1> port1, T1 expectedValue1, OutPort<T2> port2, T2 expectedValue2, OutPort<T3> port3, T3 expectedValue3) {
		return from(new OutPort<?>[] { port1, port2, port3 }, new JType[] { expectedValue1, expectedValue2, expectedValue3 });
	}
}

