package jlx.utils;

import java.util.*;

public class Venn {
	public static <T> List<Set<T>> distribute(Collection<T> elems1, Collection<T> elems2) {
		Set<T> only1 = new HashSet<T>(elems1);
		only1.removeAll(elems2);
		
		Set<T> only2 = new HashSet<T>(elems2);
		only2.removeAll(elems1);
		
		Set<T> both = new HashSet<T>(elems1);
		both.retainAll(elems2);
		
		List<Set<T>> result = new ArrayList<Set<T>>();
		result.add(only1);
		result.add(only2);
		result.add(both);
		return result;
	}
	
	public static <T> String toString(String elemsName1, Collection<T> elems1, String elemsName2, Collection<T> elems2) {
		List<Set<T>> distr = distribute(elems1, elems2);
		return "#" + elemsName1 + "=" + distr.get(0).size() + "; #" + elemsName2 + "=" + distr.get(1).size() + "; #both=" + distr.get(2).size();
	}
}
