package jlx.utils.ldd;

import java.io.*;
import java.util.*;

public class LDDGraphVizFile {
	private final List<String> elems;
	private final Set<String> tags;
	
	public LDDGraphVizFile() {
		elems = new ArrayList<String>();
		tags = new HashSet<String>();
	}
	
	public void clear() {
		elems.clear();
	}
	
	public void add(String line) {
		elems.add(line);
	}
	
	public List<String> getElems() {
		return elems;
	}
	
	public void addTag(String tag) {
		tags.add(tag);
	}
	
	public boolean isTag(String tag) {
		return tags.contains(tag);
	}
	
	public void saveToFile(PrintStream out) {
		for (String line : elems) {
			out.println(line);
		}
	}
	
	public void saveToFile(String filename) {
		try {
			File targetFile = new File(filename);
			targetFile.getCanonicalFile().getParentFile().mkdirs();
			PrintStream out = new PrintStream(new File(filename));
			saveToFile(out);
			out.close();
		} catch (IOException e) {
			throw new Error(e);
		}
	}
}
