package jlx.utils.ldd.ops;

import java.util.*;

import jlx.utils.ldd.*;
import jlx.utils.ldd.test.*;

public class LDDContainsAll {
	public static boolean containsAll(LDDNode node1, LDDNode node2) {
		if (node1.getValue() == node2.getValue()) {
			if (node2.getNextValueNode() != null) {
				if (node1.getNextValueNode() != null) {
					if (!containsAll(node1.getNextValueNode(), node2.getNextValueNode())) {
						return false;
					}
				} else {
					return false;
				}
			}
			
			if (node1.hasMoreKeys()) {
				return containsAll(node1.getNextKeyNode(), node2.getNextKeyNode());
			} else {
				return true;
			}
		} else {
			if (node1.getValue() < node2.getValue()) {
				if (node1.getNextValueNode() != null) {
					return containsAll(node1.getNextValueNode(), node2);
				} else {
					return false;
				}
			} else {
				return false;
			}
		}
	}
	
	public static void main(String[] args) {
		new LDDBoolTest("CONTAINS_ALL") {
			@Override
			public boolean test(LDD<String, String> ldd1, LDD<String, String> ldd2) {
				return ldd1.containsAll(ldd2);
			}
			
			@Override
			public boolean validate(Set<Map<String, String>> maps1, Set<Map<String, String>> maps2) {
				return maps1.containsAll(maps2);
			}
		};
	}
}

