package jlx.utils.ldd.ops;

import java.util.*;

import jlx.utils.ldd.*;
import jlx.utils.ldd.test.*;

public class LDDDisjoint {
	public static boolean isDisjoint(LDDNode node1, LDDNode node2) {
		if (node1.getValue() == node2.getValue()) {
			if (node1.getNextValueNode() != null && node2.getNextValueNode() != null) {
				if (!isDisjoint(node1.getNextValueNode(), node2.getNextValueNode())) {
					return false;
				}
			}
			
			if (node1.hasMoreKeys()) {
				return isDisjoint(node1.getNextKeyNode(), node2.getNextKeyNode());
			} else {
				return false;
			}
		} else {
			if (node1.getValue() < node2.getValue()) {
				if (node1.getNextValueNode() != null) {
					return isDisjoint(node1.getNextValueNode(), node2);
				} else {
					return true;
				}
			} else {
				if (node2.getNextValueNode() != null) {
					return isDisjoint(node1, node2.getNextValueNode());
				} else {
					return true;
				}
			}
		}
	}
	
	public static void main(String[] args) {
		new LDDBoolTest("DISJOINT") {
			@Override
			public boolean test(LDD<String, String> ldd1, LDD<String, String> ldd2) {
				return ldd1.isDisjoint(ldd2);
			}
			
			@Override
			public boolean validate(Set<Map<String, String>> maps1, Set<Map<String, String>> maps2) {
				return Collections.disjoint(maps1, maps2);
			}
		};
	}
}

