package jlx.utils.ldd.ops;

import java.util.*;

import jlx.utils.ldd.*;
import jlx.utils.ldd.test.*;

public class LDDSize {
	public static int getSize(LDDNode node) {
		LDDNode curr = node;
		int result = 0;
		
		while (curr != null) {
			if (curr.getNextKeyNode() != null) {
				result += getSize(curr.getNextKeyNode());
			} else {
				result++;
			}
			
			curr = curr.getNextValueNode();
		}
		
		return result;
	}
	
	public static void main(String[] args) {
		new LDDIntTest("SIZE") {
			@Override
			public int test(LDD<String, String> ldd1, LDD<String, String> ldd2) {
				return ldd1.size();
			}
			
			@Override
			public int validate(Set<Map<String, String>> maps1, Set<Map<String, String>> maps2) {
				return maps1.size();
			}
		};
	}
}
