package jlx.utils.ldd.test;

import java.util.*;

import jlx.utils.ldd.*;

public abstract class LDDBoolTest extends LDDTestAbstracted {
	public LDDBoolTest(String testName) {
		super(testName);
	}
	
	@Override
	public void compare(Set<Map<String, String>> maps1, Set<Map<String, String>> maps2, LDD<String, String> ldd1, LDD<String, String> ldd2) {
		boolean x = validate(maps1, maps2);
		boolean y = test(ldd1, ldd2);
		
		if (x == y) {
			if (printSuccesses()) {
				System.out.println(getTestName() + " passed!");
				System.out.println("\tInput 1:");
				printMaps(System.out, maps1);
				System.out.println("\tInput 2:");
				printMaps(System.out, maps2);
				System.out.println("\tOutput: " + x);
			}
		} else {
			System.err.println(getTestName() + " failed!");
			System.err.println("\tInput 1:");
			printMaps(System.err, maps1);
			System.err.println("\t\t" + ldd1);
			System.err.println("\tInput 2:");
			printMaps(System.err, maps2);
			System.err.println("\t\t" + ldd2);
//			System.err.println("\tTest map:");
//			printMap(System.err, getTestMap());
			System.err.println("\tOutput expected: " + x);
			System.err.println("\tBut found: " + y);
			
			ldd1.toGraphVizFile().saveToFile("ldd1.gv");
			ldd2.toGraphVizFile().saveToFile("ldd2.gv");
			
			throw new Error("LDD test failed!");
		}
	}
	
	public abstract boolean test(LDD<String, String> ldd1, LDD<String, String> ldd2);
	public abstract boolean validate(Set<Map<String, String>> maps1, Set<Map<String, String>> maps2);
}
