package models.fmics;

import java.io.IOException;
import java.util.*;

import jlx.behave.proto.*;
import jlx.behave.proto.gui.*;
import jlx.behave.stable.DecaStableTransition;
import jlx.behave.stable.DecaStableVertex;
import jlx.common.reflection.ReflectionException;
import jlx.utils.Lines;
import jlx.utils.TextOptions;
import jlx.utils.Venn;
import models.elx.p.v2x7x0A.DeutscheBahnPointModel;
import models.elx.p.v2x7x0A.scenarios.Scen001_Booting_1pm;
import models.elx.p.v2x7x0A.scenarios.Scen002_Booting_1pm;
import models.elx.p.v2x7x0A.scenarios.Scen003_Booting_1pm;
import models.elx.p.v2x7x0A.scenarios.Scen004_Booting_1pm;
import models.elx.p.v2x7x0A.scenarios.Scen039_Change_1pm;
import models.elx.p.v2x7x0A.scenarios.Scen040_Change_1pm;
import models.elx.p.v2x7x0A.scenarios.Scen041_Change_1pm;
import models.elx.p.v2x7x0A.scenarios.Scen042_Change_1pm;
import models.elx.p.v2x7x0A.scenarios.Scen043_Change_1pm;
import models.elx.p.v2x7x0A.scenarios.Scen044_Change_1pm;
import models.elx.p.v2x7x0A.scenarios.Scen045_Reversal_1pm;
import models.elx.p.v2x7x0A.scenarios.Scen046_Reversal_1pm;
import models.elx.p.v2x7x0A.scenarios.Scen047_Reversal_1pm;
import models.elx.p.v2x7x0A.scenarios.Scen048_Reversal_1pm;
import models.elx.p.v2x7x0A.scenarios.Scen049_Reversal_1pm;
import models.elx.p.v2x7x0A.scenarios.Scen050_Reversal_1pm;
import models.elx.p.v2x7x0A.scenarios.Scen051_Reversal_1pm;
import models.elx.p.v2x7x0A.scenarios.Scen052_Reversal_1pm;
import models.elx.p.v2x7x0A.scenarios.Scen053_Reversal_1pm;
import models.elx.p.v2x7x0A.scenarios.Scen054_Reversal_1pm;
import models.elx.p.v2x7x0A.scenarios.Scen055_Reversal_1pm;
import models.elx.p.v2x7x0A.scenarios.Scen056_Reversal_1pm;
import models.elx.p.v2x7x0A.scenarios.Scen057_Reversal_NonDet_1pm;
import models.elx.p.v2x7x0A.scenarios.Scen058_Reversal_NonDet_1pm;
import models.elx.p.v2x7x0A.scenarios.Scen059_Reversal_NonDet_1pm;
import models.elx.p.v2x7x0A.scenarios.Scen060_Reversal_NonDet_1pm;
import models.elx.p.v2x7x0A.scenarios.Scen061_Reversal_NonDet_1pm;
import models.elx.p.v2x7x0A.scenarios.Scen062_Reversal_NonDet_1pm;
import models.elx.p.v2x7x0A.scenarios.Scen069_Repeat_1pm;
import models.elx.p.v2x7x0A.scenarios.Scen070_Repeat_1pm;
import models.elx.p.v2x7x0A.scenarios.Scen076_Repeat_NonDet_1pm;
import models.elx.p.v2x7x0A.scenarios.Scen077_Repeat_NonDet_1pm;
import models.elx.p.v2x7x0A.scenarios.Scen079_Repeat_1pm;
import models.elx.p.v2x7x0A.scenarios.Scen080_Repeat_1pm;
import models.elx.p.v2x7x0A.scenarios.Scen081_Repeat_1pm;
import models.elx.p.v2x7x0A.scenarios.Scen082_Repeat_1pm;
import models.elx.p.v2x7x0A.scenarios.Scen083_Fallback_1pm;
import models.elx.p.v2x7x0A.scenarios.Scen084_Fallback_1pm;
import models.elx.p.v2x7x0A.scenarios.Scen085_Fallback_1pm;
import models.elx.p.v2x7x0A.scenarios.Scen086_Fallback_1pm;
import models.elx.p.v2x7x0A.scenarios.Scen087_Fallback_1pm;
import models.elx.p.v2x7x0A.scenarios.Scen088_Fallback_1pm;
import models.elx.p.v2x7x0A.scenarios.Scen089_Fallback_1pm;
import models.elx.p.v2x7x0A.scenarios.Scen090_Disconnect_1pm;
import models.elx.p.v2x7x0A.scenarios.Scen091_Disconnect_1pm;
import models.elx.p.v2x7x0A.scenarios.Scen092_Disconnect_1pm;
import models.elx.p.v2x7x0A.scenarios.Scen093_Disconnect_1pm;
import models.elx.p.v2x7x0A.scenarios.Scen094_Timeout_1pm;
import models.elx.p.v2x7x0A.scenarios.Scen095_Timeout_1pm;
import models.elx.p.v2x7x0A.scenarios.Scen096_Timeout_1pm;
import models.elx.p.v2x7x0A.scenarios.Scen097_Timeout_1pm;
import models.elx.p.v2x7x0A.scenarios.Scen098_Timeout_1pm;
import models.elx.p.v2x7x0A.scenarios.Scen099_Timeout_1pm;
import models.elx.p.v2x7x0A.scenarios.Scen100_Timeout_1pm;
import models.elx.p.v2x7x0A.scenarios.Scen101_Timeout_1pm;
import models.elx.p.v2x7x0A.scenarios.Scen102_Timeout_1pm;
import models.elx.p.v2x7x0A.scenarios.Scen103_Timeout_1pm;
import models.elx.p.v2x7x0A.scenarios.Scen104_Timeout_1pm;
import models.elx.p.v2x7x0A.scenarios.Scen105_Timeout_1pm;
import models.elx.p.v2x7x0A.scenarios.Scen106_LoseEP_1pm;
import models.elx.p.v2x7x0A.scenarios.Scen107_LoseEP_1pm;
import models.elx.p.v2x7x0A.scenarios.Scen108_LoseEP_1pm;
import models.elx.p.v2x7x0A.scenarios.Scen109_Trail_1pm;
import models.elx.p.v2x7x0A.scenarios.Scen110_Trail_1pm;
import models.elx.p.v2x7x0A.scenarios.Scen111_NoInstructChange_1pm;
import models.elx.p.v2x7x0A.scenarios.Scen112_NoInstructChange_1pm;
import models.elx.p.v2x7x0A.scenarios.Scen113_NoInstructChange_1pm;
import models.elx.p.v2x7x0A.scenarios.Scen114_NoInstructChange_1pm;
import models.elx.p.v2x7x0A.scenarios.Scen139_PowerLoss_1pm;
import models.elx.p.v2x7x0A.scenarios.Scen140_PowerLoss_1pm;
import models.elx.p.v2x7x0A.scenarios.Scen141_PowerLoss_1pm;
import models.elx.p.v2x7x0A.scenarios.Scen142_PowerLoss_1pm;
import models.elx.p.v2x7x0A.scenarios.Scen143_Reset_1pm;
import models.elx.p.v2x7x0A.scenarios.Scen144_Reset_1pm;
import models.elx.p.v2x7x0A.scenarios.Scen145_Disconnect_NonDet_1pm;
import models.elx.p.v2x7x0A.scenarios.Scen146_Disconnect_NonDet_1pm;
import models.elx.p.v2x7x0A.scenarios.Scen147_Disconnect_NonDet_1pm;
import models.elx.p.v2x7x0A.scenarios.Scen148_Disconnect_NonDet_1pm;
import models.elx.p.v2x7x0A.scenarios.Scen149_Disconnect_NonDet_1pm;
import models.elx.p.v2x7x0A.scenarios.Scen150_Disconnect_NonDet_1pm;
import models.elx.p.v2x7x0A.scenarios.Scen151_DisconnectPosChange_1pm;
import models.elx.p.v2x7x0A.scenarios.Scen152_DisconnectPosChange_1pm;
import models.elx.p.v2x7x0A.scenarios.Scen153_DisconnectPosChange_1pm;
import models.elx.p.v2x7x0A.scenarios.Scen154_DisconnectPosChange_1pm;
import models.elx.p.v2x7x0A.scenarios.Scen155_DisconnectPosChange_1pm;
import models.elx.p.v2x7x0A.scenarios.Scen156_DisconnectPosChange_1pm;

public class Point_PlayScenarios {
	private static SortedMap<String, DecaTwoTransition> smdElems = new TreeMap<String, DecaTwoTransition>();
	private static SortedMap<String, DecaTwoTransition> selfLoopElems = new TreeMap<String, DecaTwoTransition>();
	private static SortedMap<String, DecaTwoTransition> untriggeredElems = new TreeMap<String, DecaTwoTransition>();
	private static SortedMap<String, DecaTwoTransition> unreachedElems = new TreeMap<String, DecaTwoTransition>();
	private static Set<DecaTwoTransition> unreachedElems2 = new HashSet<DecaTwoTransition>();
	
	private static void __printReachedElems(Lines dest, DecaTwoTransition start, String prefix, Collection<DecaTwoTransition> transitions, Collection<DecaTwoTransition> beenHere, Set<DecaTwoVertex> vtxsFound) {
		vtxsFound.add(start.getSrc());
		vtxsFound.add(start.getTgt());
		
		for (DecaTwoTransition t : transitions) {
			if (t.getSrc().equals(start.getTgt())) {
				if (!beenHere.contains(t)) {
					unreachedElems2.add(t);
					
					Set<DecaTwoTransition> newTransitions = new HashSet<DecaTwoTransition>(transitions);
					newTransitions.add(t);
					Set<DecaTwoTransition> newBeenHere = new HashSet<DecaTwoTransition>(beenHere);
					newBeenHere.add(t);
					
					dest.getElems().add(prefix + t.toString());
					__printReachedElems(dest, t, prefix + "\t", newTransitions, newBeenHere, vtxsFound);
				}
			}
		}
	}
	
	private static Set<DecaTwoVertex> printReachedElems(Lines dest, DecaTwoTransition start) {
		Set<DecaTwoVertex> result = new HashSet<DecaTwoVertex>();
		__printReachedElems(dest, start, "\t", unreachedElems.values(), Collections.singleton(start), result);
		return result;
	}
	
	public static void main(String[] args) throws ReflectionException, IOException {
		DeutscheBahnPointModel m = new DeutscheBahnPointModel(false, false, false, false);
//		System.exit(0);
		DecaFourScenarioPlayer player = new DecaFourScenarioPlayer(m.get_ub());
		
		if ("det-tests".equals("det-tests")) {
			player.play(new Scen001_Booting_1pm(m), null);
			player.play(new Scen002_Booting_1pm(m), null);
			player.play(new Scen003_Booting_1pm(m), null);
			player.play(new Scen004_Booting_1pm(m), null);
			player.play(new Scen039_Change_1pm(m), null);
			player.play(new Scen040_Change_1pm(m), null);
			player.play(new Scen041_Change_1pm(m), null);
			player.play(new Scen042_Change_1pm(m), null);
			player.play(new Scen043_Change_1pm(m), null);
			player.play(new Scen044_Change_1pm(m), null);
			player.play(new Scen045_Reversal_1pm(m), null);
			player.play(new Scen046_Reversal_1pm(m), null);
			player.play(new Scen047_Reversal_1pm(m), null);
			player.play(new Scen048_Reversal_1pm(m), null);
			player.play(new Scen049_Reversal_1pm(m), null);
			player.play(new Scen050_Reversal_1pm(m), null);
			player.play(new Scen051_Reversal_1pm(m), null);
			player.play(new Scen052_Reversal_1pm(m), null);
			player.play(new Scen053_Reversal_1pm(m), null);
			player.play(new Scen054_Reversal_1pm(m), null);
			player.play(new Scen055_Reversal_1pm(m), null);
			player.play(new Scen056_Reversal_1pm(m), null);
			player.play(new Scen069_Repeat_1pm(m), null);
			player.play(new Scen070_Repeat_1pm(m), null);
			player.play(new Scen079_Repeat_1pm(m), null);
			player.play(new Scen080_Repeat_1pm(m), null);
			player.play(new Scen081_Repeat_1pm(m), null);
			player.play(new Scen082_Repeat_1pm(m), null);
			player.play(new Scen083_Fallback_1pm(m), null);
			player.play(new Scen084_Fallback_1pm(m), null);
			player.play(new Scen085_Fallback_1pm(m), null);
			player.play(new Scen086_Fallback_1pm(m), null);
			player.play(new Scen087_Fallback_1pm(m), null);
			player.play(new Scen088_Fallback_1pm(m), null);
			player.play(new Scen089_Fallback_1pm(m), null);
			player.play(new Scen090_Disconnect_1pm(m), null);
			player.play(new Scen091_Disconnect_1pm(m), null);
			player.play(new Scen092_Disconnect_1pm(m), null);
			player.play(new Scen093_Disconnect_1pm(m), null);
			player.play(new Scen094_Timeout_1pm(m), null);
			player.play(new Scen095_Timeout_1pm(m), null);
			player.play(new Scen096_Timeout_1pm(m), null);
			player.play(new Scen097_Timeout_1pm(m), null);
			player.play(new Scen098_Timeout_1pm(m), null);
			player.play(new Scen099_Timeout_1pm(m), null);
			player.play(new Scen100_Timeout_1pm(m), null);
			player.play(new Scen101_Timeout_1pm(m), null);
			player.play(new Scen102_Timeout_1pm(m), null);
			player.play(new Scen103_Timeout_1pm(m), null);
			player.play(new Scen104_Timeout_1pm(m), null);
			player.play(new Scen105_Timeout_1pm(m), null);
			player.play(new Scen106_LoseEP_1pm(m), null);
			player.play(new Scen107_LoseEP_1pm(m), null);
			player.play(new Scen108_LoseEP_1pm(m), null);
			player.play(new Scen109_Trail_1pm(m), null);
			player.play(new Scen110_Trail_1pm(m), null);
			player.play(new Scen111_NoInstructChange_1pm(m), null);
			player.play(new Scen112_NoInstructChange_1pm(m), null);
			player.play(new Scen113_NoInstructChange_1pm(m), null);
			player.play(new Scen114_NoInstructChange_1pm(m), null);
			player.play(new Scen139_PowerLoss_1pm(m), null);
			player.play(new Scen140_PowerLoss_1pm(m), null);
			player.play(new Scen141_PowerLoss_1pm(m), null);
			player.play(new Scen142_PowerLoss_1pm(m), null);
			player.play(new Scen143_Reset_1pm(m), null);
			player.play(new Scen144_Reset_1pm(m), null);
			player.play(new Scen151_DisconnectPosChange_1pm(m), null);
			player.play(new Scen152_DisconnectPosChange_1pm(m), null);
			player.play(new Scen153_DisconnectPosChange_1pm(m), null);
			player.play(new Scen154_DisconnectPosChange_1pm(m), null);
			player.play(new Scen155_DisconnectPosChange_1pm(m), null);
			player.play(new Scen156_DisconnectPosChange_1pm(m), null);
		}
		
		if ("nondet-tests".equals("nondet-tests")) {
			player.play(new Scen057_Reversal_NonDet_1pm(m), null);
			player.play(new Scen058_Reversal_NonDet_1pm(m), null);
			player.play(new Scen059_Reversal_NonDet_1pm(m), null);
			player.play(new Scen060_Reversal_NonDet_1pm(m), null);
			player.play(new Scen061_Reversal_NonDet_1pm(m), null);
			player.play(new Scen062_Reversal_NonDet_1pm(m), null);
			player.play(new Scen076_Repeat_NonDet_1pm(m), null);
			player.play(new Scen077_Repeat_NonDet_1pm(m), null);
			player.play(new Scen145_Disconnect_NonDet_1pm(m), null);
			player.play(new Scen146_Disconnect_NonDet_1pm(m), null);
			player.play(new Scen147_Disconnect_NonDet_1pm(m), null);
			player.play(new Scen148_Disconnect_NonDet_1pm(m), null);
			player.play(new Scen149_Disconnect_NonDet_1pm(m), null);
			player.play(new Scen150_Disconnect_NonDet_1pm(m), null);
		}
		
		//72 applied tests
		//(minus) 16 + 6 + 22 = 44 2pm tests
		//(minus) 18 unclear tests
		//(minus?) 6 + 2 + 6 = 14 non-det tests
		//(minus) 4 duplicate tests
		//(minus) 2 time tests
		//(minus) 12 unfinished tests
		//
		//(TOTAL) 72, 116, 134, 148, 152, 154, 166
		
		System.out.println("Found " + player.getPotVisitedCfgs().size() + " in total");
		
		for (DecaFourStateConfig cfg : player.getPotVisitedCfgs()) {
			System.out.println("Found: " + cfg.getDescription());
		}
		
		LineageObjects playerObjects = new LineageObjects("PLAYER", player.getLineageObjects());
		LineageObjects sicObjects = new LineageObjects("SIC", m.get_ub().stableSm.getLineageObjects());
		LineageObjects allObjects = new LineageObjects("MAX", m.get_ub().sms4.getLineageObjects());
		LineageObjects stableObjects = new LineageObjects("STABLE", m.get_ub().stableSm.getStableLineageObjects());
		
		if ("freqs".equals("freqs")) {
			LineageObjects.printFreqs("dbef.freq", playerObjects, sicObjects, allObjects);
			LineageObjects.printDiffs("dbef.diff", playerObjects, sicObjects, allObjects);
			
			LineageObjects.printFreqs("dbef.stab.freq", stableObjects, allObjects);
			LineageObjects.printDiffs("dbef.stab.diff", stableObjects, allObjects);
			
			LineageObjects.printVerticesPerComp("dbef.vtxcomp", playerObjects, sicObjects, allObjects);
			LineageObjects.printTransitionsPerComp("dbef.trcomp", playerObjects, sicObjects, allObjects);
		}
		
		LineageObjectsDiff diff1 = new LineageObjectsDiff(playerObjects.getElems(), sicObjects.getElems(), ProtoVertex.class, m.get_ub().stableSm);
		diff1.createLines().saveToFile("missing-proto-vertices.txt");
		
		LineageObjectsDiff diff2 = new LineageObjectsDiff(playerObjects.getElems(), sicObjects.getElems(), ProtoTransition.class, m.get_ub().stableSm);
		diff2.createLines().saveToFile("missing-proto-transitions.txt");
		
		LineageObjectsDiff diff3 = new LineageObjectsDiff(playerObjects.getElems(), sicObjects.getElems(), DecaTwoVertex.class, m.get_ub().stableSm);
		diff3.createLines().saveToFile("missing-deca-two-vertices.txt");
		
		LineageObjectsDiff diff4 = new LineageObjectsDiff(playerObjects.getElems(), sicObjects.getElems(), (x) -> {
			if (DecaTwoTransition.class.isAssignableFrom(x.getClass())) {
				DecaTwoTransition t = DecaTwoTransition.class.cast(x);
				
				if (t.getSrc() == t.getTgt()) {
					selfLoopElems.put(t.toString(), t);
				} else {
					//We can exclude transitions derived from SMD transitions that were not covered:
					if (!Collections.disjoint(t.aggregateLineageObjects(), diff2.getMissingElems())) {
						smdElems.put(t.toString(), t);
					} else {
						//Only list transitions that are actually reached:
						if (playerObjects.getElems().contains(t.getSrc())) {
							untriggeredElems.put(t.toString(), t);
						} else {
							unreachedElems.put(t.toString(), t);
						}
					}
				}
				
				return true;
			}
			
			return false;
		}, m.get_ub().stableSm);
		diff4.createLines().saveToFile("missing-deca-two-transitions.txt");
		
//		LineageObjectsDiff diff5 = new LineageObjectsDiff(sicObjects.getElems(), playerObjects.getElems(), (x) -> {
//			if (DecaTwoTransition.class.isAssignableFrom(x.getClass())) {
//				DecaTwoTransition t = DecaTwoTransition.class.cast(x);
//				
//				return true;
//			}
//			
//			return false;
//		}, m.get_ub().stableSm);
		
		System.out.println("smdCount = " + smdElems.size());
		System.out.println("selfLoopCount = " + selfLoopElems.size());
		System.out.println("untriggeredCount = " + untriggeredElems.size());
		System.out.println("unreachedCount = " + unreachedElems.size());
		
		Lines lines = new Lines();
		
		for (DecaTwoTransition t : smdElems.values()) {
			lines.add("SMD-ELEM: " + t.toString());
			
			for (DecaTwoVertex vtx : printReachedElems(lines, t)) {
				if (!playerObjects.getElems().contains(vtx)) {
					lines.add("\t" + vtx.toString());
				}
			}
		}
		
		for (DecaTwoTransition t : selfLoopElems.values()) {
			lines.add("SELF-LOOP-ELEM: " + t.toString());
		}
		
		for (DecaTwoTransition t : untriggeredElems.values()) {
			lines.add("UNTRIGGERED-ELEM: " + t.toString());
			
			for (DecaTwoVertex vtx : printReachedElems(lines, t)) {
				if (!playerObjects.getElems().contains(vtx)) {
					lines.add("\t" + vtx.toString());
				}
			}
		}
		
		lines.saveToFile("missing-elems-2.txt");
		
		System.out.println("Reached " + unreachedElems2.size() + " of " + unreachedElems.size() + " unreached transitions!");
		
		int playerOnlyCoverageCount = 0;
		int playerAndSicCoverageCount = 0;
		int sicOnlyCoverageCount = 0;
		int sicReachInStableCount = 0;
		int sicReachInUnstableCount = 0;
		int otherCount = 0;
		
		for (LineageObject elem : allObjects.getElems()) {
			if (elem instanceof DecaTwoTransition) {
				DecaTwoTransition t = (DecaTwoTransition)elem;
				
				if (playerObjects.getElems().contains(t)) {
					if (sicObjects.getElems().contains(t)) {
						playerAndSicCoverageCount++;
					} else {
						playerOnlyCoverageCount++;
					}
				} else {
					if (sicObjects.getElems().contains(t)) {
						sicOnlyCoverageCount++;
					} else {
						if (stableObjects.getElems().contains(t.getSrc())) {
							sicReachInStableCount++;
						} else {
							if (sicObjects.getElems().contains(t.getSrc())) {
								sicReachInUnstableCount++;
							} else {
								otherCount++;
							}
						}
					}
				}
			}
		}
		
		System.out.println("   playerOnlyCoverageCount = " + playerOnlyCoverageCount);
		System.out.println(" playerAndSicCoverageCount = " + playerAndSicCoverageCount);
		System.out.println("      sicOnlyCoverageCount = " + sicOnlyCoverageCount);
		System.out.println("     sicReachInStableCount = " + sicReachInStableCount);
		System.out.println("   sicReachInUnstableCount = " + sicReachInUnstableCount);
		System.out.println("                otherCount = " + otherCount);
		
		Set<DecaStableVertex> stablePlayerVtxs = new HashSet<DecaStableVertex>();
		Set<DecaFourStateConfig> unstablePlayerCfgs = new HashSet<DecaFourStateConfig>();
		
		for (DecaStableTransition t : player.getStableTrs()) {
			stablePlayerVtxs.add(t.getSrc());
			stablePlayerVtxs.add(t.getTgt());
			unstablePlayerCfgs.addAll(t.getSeq());
		}
		
		System.out.println("stab-vtxs: " + Venn.toString("player", stablePlayerVtxs, "sic", m.get_ub().stableSm.vertices));
		System.out.println("cfgs1:     " + Venn.toString("player", extractCfgs(stablePlayerVtxs), "sic", extractCfgs(m.get_ub().stableSm.vertices)));
		System.out.println("cfgs2:     " + Venn.toString("player", unstablePlayerCfgs, "sic", m.get_ub().stableSm.coveredCfgs));
		
		System.out.println("#player.stableVtxs = " + stablePlayerVtxs.size() + " / " + m.get_ub().stableSm.vertices.size() + " / " + m.get_ub().sms4.potStableCfgs.size());
		System.out.println("#player.cfgs = " + extractCfgs(stablePlayerVtxs).size() + " / " + extractCfgs(m.get_ub().stableSm.vertices).size() + " / " + m.get_ub().sms4.potStableCfgs.size() + " / " + m.get_ub().sms4.configs.size());
		System.out.println("#player.stableTrs = " + new HashSet<DecaStableTransition>(player.getStableTrs()).size() + " / " + player.getStableTrs().size() + " / " + m.get_ub().stableSm.transitions.size());
		System.out.println("#player.unstableTrs = " + player.getNoStableTrCount());
		System.out.println("#player.steps = " + player.getStepCount());
		
		int interestingCount = 0;
		
		for (DecaStableTransition t : m.get_ub().stableSm.transitions) {
			if (t.getSicInputs1() != null) {
				if (!t.getSrc().getCfg().equals(t.getTgt().getCfg())) {
					interestingCount++;
				}
			}
		}
		
		System.out.println("#interesting = " + interestingCount);
		
		{
			Lines xs = new Lines();
			xs.add("digraph G {");
//			xs.add("\tlayout=sfdp;");
			
			Map<DecaFourStateConfig, String> namePerCfg = new HashMap<DecaFourStateConfig, String>();
			
			for (DecaFourStateConfig cfg : extractCfgs(stablePlayerVtxs)) {
				namePerCfg.put(cfg, "X" + namePerCfg.size());
			}
			
			Map<DecaFourCfgPair, String> namePerCfgPair = new HashMap<DecaFourCfgPair, String>();
			
			for (DecaFourCfgPair cfgPair : player.getCfgPairs()) {
				namePerCfgPair.put(cfgPair, "P" + namePerCfgPair.size());
			}
			
			xs.add("\tnode [label=\"\", style=filled, fillcolor=black, color=black, shape=circle, width=0.2];");
			
			TextOptions.select(TextOptions.GRAPHVIZ_MIN);
			xs.add("\t" + namePerCfg.get(m.get_ub().stableSm.initialTransition.getTgt().getCfg()) + " [shape=doublecircle];");
			
			for (Map.Entry<DecaFourStateConfig, String> e : namePerCfg.entrySet()) {
				if (!e.getKey().equals(m.get_ub().stableSm.initialTransition.getTgt().getCfg())) {
					xs.add("\t" + e.getValue() + ";");
				}
			}
			
//			xs.add("\tnode [label=\"\", style=filled, fillcolor=white, color=black, shape=rect, fontsize=6, margin=0.05, width=0, height=0];");
//			
//			for (Map.Entry<DecaFourCfgPair, Set<Integer>> e : player.getSteps().entrySet()) {
//				Iterator<Integer> q = e.getValue().iterator();
//				String s = "" + q.next();
//				String t = s;
//				
//				while (q.hasNext()) {
//					Integer next = q.next();
//					
//					if (t.length() >= 15) {
//						s += ",\\n" + next;
//						t = "" + next;
//					} else {
//						s += ", " + next;
//						t += ", " + next;
//					}
//				}
//				
//				xs.add("\t" + namePerCfgPair.get(e.getKey()) + " [label=\"" + s + "\"];");
//			}
//			
//			for (DecaFourCfgPair cfgPair : namePerCfgPair.keySet()) {
//				String src = namePerCfg.get(cfgPair.getSrc());
//				String mid = namePerCfgPair.get(cfgPair);
//				String tgt = namePerCfg.get(cfgPair.getTgt());
//				xs.add("\t" + src + " -> " + mid + " [arrowhead=none];");
//				xs.add("\t" + mid + " -> " + tgt + ";");
//			}
			
			xs.add("\tedge [fontsize=8];");
			
			for (DecaFourCfgPair cfgPair : namePerCfgPair.keySet()) {
				Iterator<Integer> q = player.getSteps().get(cfgPair).iterator();
				String s = "" + q.next();
				String t = s;
				
				while (q.hasNext()) {
					Integer next = q.next();
					
					if (t.length() >= 15) {
						s += ",\\n" + next;
						t = "" + next;
					} else {
						s += ", " + next;
						t += ", " + next;
					}
				}
				
				String src = namePerCfg.get(cfgPair.getSrc());
				String tgt = namePerCfg.get(cfgPair.getTgt());
				xs.add("\t" + src + " -> " + tgt + " [label=\"" + "" + "\"];");
			}
			
			xs.add("}");
			xs.saveToFile("player.gv");
		}
		
		{
			
			
			Lines xs = new Lines();
			xs.add("digraph G {");
			xs.add("\tlayout=sfdp;");
			
			Map<DecaFourStateConfig, String> namePerCfg = new HashMap<DecaFourStateConfig, String>();
			
			for (DecaFourStateConfig cfg : extractCfgs(m.get_ub().stableSm.vertices)) {
				namePerCfg.put(cfg, "X" + namePerCfg.size());
			}
			
			TextOptions.select(TextOptions.GRAPHVIZ_MIN);
			for (Map.Entry<DecaFourStateConfig, String> e : namePerCfg.entrySet()) {
				//xs.add("\t" + e.getValue() + " [label=\"" + e.getKey().getDescription("\\n") + "\", shape=rect];");
				xs.add("\t" + e.getValue() + " [label=\"\", shape=circle, style=filled, color=black];");
			}
			
			for (DecaFourCfgPair cfgPair : m.get_ub().stableSm.getCfgPairs()) {
				String src = namePerCfg.get(cfgPair.getSrc());
				String tgt = namePerCfg.get(cfgPair.getTgt());
				//xs.add("\t" + src + " -> " + tgt + " [label=\"" + cfgPair.getInputVal().toString() + "\"];");
				xs.add("\t" + src + " -> " + tgt + " [label=\"\"];");
			}
			
			xs.add("}");
			xs.saveToFile("stable.gv");
		}
		
//		Set<DecaTwoVertex> missingVertices = new HashSet<DecaTwoVertex>();
//		
//		for (LineageObject x : sicObjects.getElems()) {
//			if (x instanceof DecaTwoVertex) {
//				if (!scenarioObjects.getElems().contains(x)) {
//					missingVertices.add((DecaTwoVertex)x);
//				}
//			}
//		}
//		
//		Lines file = new Lines();
//		
//		Map<DecaTwoVertex, DecaStableVertex> bestVtxPerMissingStableVertex = new HashMap<DecaTwoVertex, DecaStableVertex>();
//		
//		for (DecaStableVertex v : m.get_ub().stableSm.vertices) {
//			Set<LineageObject> temp = new HashSet<LineageObject>(v.aggregateLineageObjects());
//			temp.retainAll(missingVertices);
//			
//			for (LineageObject tgt : temp) {
//				DecaStableVertex w = bestVtxPerMissingStableVertex.get(tgt);
//				
//				if (w == null || v.getLevel() < w.getLevel()) {
//					bestVtxPerMissingStableVertex.put((DecaTwoVertex)tgt, v);
//				}
//			}
//		}
//		
//		missingVertices.removeAll(bestVtxPerMissingStableVertex.keySet());
//		Map<DecaTwoVertex, DecaStableTransition> bestVtxPerMissingUnstableVertex = new HashMap<DecaTwoVertex, DecaStableTransition>();
//		
//		for (DecaStableTransition t : m.get_ub().stableSm.transitions) {
//			Set<LineageObject> temp = new HashSet<LineageObject>(t.aggregateLineageObjects());
//			temp.retainAll(missingVertices);
//			
//			for (LineageObject tgt : temp) {
//				DecaStableTransition w = bestVtxPerMissingUnstableVertex.get(tgt);
//				
//				if (w == null || t.getSrc().getLevel() < w.getSrc().getLevel()) {
//					bestVtxPerMissingUnstableVertex.put((DecaTwoVertex)tgt, t);
//				}
//			}
//		}
//		
//		for (Map.Entry<DecaTwoVertex, DecaStableVertex> e : bestVtxPerMissingStableVertex.entrySet()) {
//			file.add("STABLE_TARGET = " + e.getKey().toString());
//			
//			int index = 1;
//			
//			for (DecaStableTransition t : m.get_ub().stableSm.getTransitionsToVertex(e.getValue())) {
//				file.add("\t" + index + ": " + t.toString().replace("\n", "\n\t\t"));
//				index++;
//			}
//			
//			if (file.getElems().size() > 10000) {
//				file.add(". . . Reached line limit . . .");
//				break;
//			}
//		}
//		
//		file.saveToFile("missing-deca-two-vertices.txt");
//		file.clear();
//		
//		for (Map.Entry<DecaTwoVertex, DecaStableTransition> e : bestVtxPerMissingUnstableVertex.entrySet()) {
//			file.add("UNSTABLE_TARGET = " + e.getKey().toString());
//			
//			int index = 1;
//			
//			for (DecaStableTransition t : m.get_ub().stableSm.getTransitionsToVertex(e.getValue().getSrc())) {
//				file.add("\t" + index + ": " + t.toString().replace("\n", "\n\t\t"));
//				index++;
//			}
//			
//			file.add("\t" + index + ": " + e.getValue().toString().replace("\n", "\n\t\t"));
//			
//			if (file.getElems().size() > 10000) {
//				file.add(". . . Reached line limit . . .");
//				break;
//			}
//		}
//		
//		file.saveToFile("missing-deca-two-vertices-unstable.txt");
		
		System.out.println("#potStableCfgs = " + m.get_ub().sms4.potStableCfgs.size());
		
//		for (ProtoTransition t : player.getCoverageStats().getTransitions()) {
//			System.out.println("Found: " + t.toString());
//		}
//		
//		Set<ProtoVertex> protoVtxs = player.getCoverageStats().getVertices();
//		Set<ProtoTransition> protoTrs = player.getCoverageStats().getTransitions();
//		Set<DecaFourVertex> decaFourVtxs = player.getCoverageStats().getVertices4();
//		Set<DecaFourTransition> decaFourTrs = player.getCoverageStats().getTransitions4();
//		
//		for (ProtoVertex v : protoVtxs) {
//			System.out.println("Found: " + v.toString());
//		}
//		
//		System.out.println("#cfgs = " + player.getPotVisitedCfgs().size() + " / " + m.get_ub().sms4.configs.size());
//		System.out.println("#deca-four-vtxs = " + decaFourVtxs.size() + " / " + m.get_ub().sms4.coverageStats.getVertices4().size() + " / " + m.get_ub().sms4.vertices.size());
//		System.out.println("#deca-four-trs = " + decaFourTrs.size() + " / " + m.get_ub().sms4.coverageStats.getTransitions4().size() + " / " + m.get_ub().sms4.transitions.size());
//		System.out.println("#proto-vtxs = " + protoVtxs.size() + " / " + m.get_ub().sms4.getAllProtoVertices2().size() + " / " + m.get_ub().sms4.getAllProtoVertices().size());
//		System.out.println("#proto-trs = " + protoTrs.size() + " / " + m.get_ub().sms4.getAllProtoTransitions2().size() + " / " + m.get_ub().sms4.getAllProtoTransitions().size());
//		
//		for (ProtoVertex v : m.get_ub().stableSm.coverageStats.getVertices()) {
//			if (!protoVtxs.contains(v)) {
//				System.out.println("MissingV: " + v.toString());
//			}
//		}
//		
//		for (DecaFourVertex v : m.get_ub().stableSm.coverageStats.getVertices4()) {
//			if (!decaFourVtxs.contains(v)) {
//				System.out.println("MissingV4: " + v.toString());
//			}
//		}
//		
//		for (ProtoTransition v : m.get_ub().stableSm.coverageStats.getTransitions()) {
//			if (!protoTrs.contains(v)) {
//				System.out.println("MissingT: " + v.toString());
//			}
//		}
//		
//		for (DecaFourTransition v : m.get_ub().stableSm.coverageStats.getTransitions4()) {
//			if (!decaFourTrs.contains(v)) {
//				System.out.println("MissingT4: " + v.toString());
//			}
//		}
//		
//		for (ProtoVertex v : m.get_ub().stableSm.coverageStats.getVertices()) {
//			if (!protoVtxs.contains(v)) {
//				System.out.println("MissingV: " + v.toString());
//			}
//		}
//		
//		for (DecaFourVertex v : m.get_ub().stableSm.coverageStats.getVertices4()) {
//			if (!decaFourVtxs.contains(v)) {
//				System.out.println("MissingV4: " + v.toString());
//			}
//		}
//		
//		for (ProtoTransition v : m.get_ub().stableSm.coverageStats.getTransitions()) {
//			if (!protoTrs.contains(v)) {
//				System.out.println("MissingT: " + v.toString());
//			}
//		}
//		
//		for (DecaFourTransition v : m.get_ub().stableSm.coverageStats.getTransitions4()) {
//			if (!decaFourTrs.contains(v)) {
//				System.out.println("MissingT4: " + v.toString());
//			}
//		}
//		
//		System.out.println("[stable] #cfgs = " + m.get_ub().stableSm.coveredCfgs.size() + " / " + m.get_ub().sms4.configs.size());
//		System.out.println("[stable] #deca-four-vtxs = " + m.get_ub().stableSm.coverageStats.getVertices4().size() + " / " + m.get_ub().sms4.coverageStats.getVertices4().size() + " / " + m.get_ub().sms4.vertices.size());
//		System.out.println("[stable] #deca-four-trs = " + m.get_ub().stableSm.coverageStats.getTransitions4().size() + " / " + m.get_ub().sms4.coverageStats.getTransitions4().size() + " / " + m.get_ub().sms4.transitions.size());
//		System.out.println("[stable] #proto-vtxs = " + m.get_ub().stableSm.coverageStats.getVertices().size() + " / " + m.get_ub().sms4.getAllProtoVertices2().size() + " / " + m.get_ub().sms4.getAllProtoVertices().size());
//		System.out.println("[stable] #proto-trs = " + m.get_ub().stableSm.coverageStats.getTransitions().size() + " / " + m.get_ub().sms4.getAllProtoTransitions2().size() + " / " + m.get_ub().sms4.getAllProtoTransitions().size());
//		
////		#cfgs = 172 / 13.322.223
////		#proto-vtxs = 68 / 75 / 77
////		#proto-trs = 126 / 163 / 168
////		Missing: models.generic.v3x0x0A.SCI_EfeS_Prim_STD_1.PDI_TELEGRAM_ERROR
////		Missing: models.generic.v3x0x0A.SCI_EfeS_Prim_STD_1.PDI_CONNECTION_IMPERMISSIBLE
////		Missing: models.generic.v3x0x0A.SCI_EfeS_Prim_STD_1.PDI_PROTOCOL_ERROR
////		Missing: models.generic.v3x0x0A.SCI_EfeS_Sec_STD_1.PDI_CONNECTION_IMPERMISSIBLE
////		Missing: models.generic.v3x0x0A.SCI_EfeS_Sec_STD_1.PDI_TELEGRAM_ERROR
////		Missing: models.generic.v3x0x0A.SCI_EfeS_Prim_STD_1.PDI_INIT_TIMEOUT
////		Missing: models.generic.v3x0x0A.SCI_EfeS_Sec_STD_1.PDI_PROTOCOL_ERROR
//		
////		#cfgs = 173 / 13322223
////		#deca-four-vtxs = 118 / 171 / 264
////		#deca-four-trs = 118 / 3280 / 6228
////		#proto-vtxs = 68 / 75 / 77
////		#proto-trs = 126 / 163 / 168
//		
////		[stable] #cfgs = 56914 / 13322223
////		[stable] #deca-four-vtxs = 150 / 171 / 264
////		[stable] #deca-four-trs = 360 / 3280 / 6228
////		[stable] #proto-vtxs = 75 / 75 / 77
////		[stable] #proto-trs = 162 / 163 / 168
//		
////		for (ProtoTransition t : m.get_ub().sms4.getAllProtoTransitions()) {
////			if (!protoTrs.contains(t)) {
////				System.out.println("MissingV: " + t.toString());
////			}
////		}
	}
	
	private static Set<DecaFourStateConfig> extractCfgs(Set<DecaStableVertex> vtxs) {
		Set<DecaFourStateConfig> result = new HashSet<DecaFourStateConfig>();
		
		for (DecaStableVertex vtx : vtxs) {
			result.add(vtx.getCfg());
		}
		
		return result;
	}
}

