package models.fmics;

import java.io.IOException;
import java.util.*;

import jlx.behave.stable.files.*;
import jlx.behave.stable.files.DecaStableFile.*;
import jlx.common.reflection.ReflectionException;

public class Point_TestGen_Sttt_Questions {
	public static void main(String[] args) throws ReflectionException, IOException {
		DecaStableFileWriter r = new DecaStableFileWriter();
//		r.loadFromFile("output", "point.trcov.sic", false);
		r.loadFromFile("output", "point.trlabcov.sic", false);
		
		//Questions:
		// 1. Number of SIC-DFSM transitions that are reached by label coverage.
		// 2. Number of STD transitions that are reached by label coverage.
		
		Set<Integer> totalTransitions = new HashSet<Integer>();
		totalTransitions.add(r.getInitialTransition().getId());
		
		for (Transition t : r.getTransitions()) {
			totalTransitions.add(t.getId());
		}
		
		System.out.println("#total-SIC-DFSM-transitions = " + totalTransitions.size());
		
		Set<Integer> labelTransitions = new HashSet<Integer>();
		
		for (TestSuite ts : r.getTestSuites()) {
			for (Trace t : ts.getTests()) {
				for (Transition step : t.getTransitions()) {
					labelTransitions.add(step.getId());
				}
			}
		}
		
		System.out.println("#label-SIC-DFSM-transitions = " + labelTransitions.size());
		
		//2664 distinct transitions of the SIC-DFSM are covered by the test suite for transtion label coverage (0.15%)
	}
}

