package models.mini.thesis;

import jlx.behave.*;

public class FlatteningSMD extends FlatteningIBD.Block implements StateMachine {
	public class Init1 extends InitialState {
		@Override
		public Outgoing[] getOutgoing() {
			return new Outgoing[] {
				new Outgoing(A.class, none(invokeStat(AInit)))
			};
		}
	}
	
	public class A extends CompositeState {
		@Override
		public Entry onEntry() {
			return new Entry(invokeStat(AEntry));
		}
		
		@Override
		public Exit onExit() {
			return new Exit(invokeStat(AExit));
		}
		
		@Override
		public Do[] onDo() {
			return new Do[] {
				new Do(when(X, invokeStat(ADo)))
			};
		}
		
		@Override
		public Outgoing[] getOutgoing() {
			return new Outgoing[] {
				new Outgoing(A.class, when(W, invokeStat(AW)))
			};
		}
		
		public class Init2 extends InitialState {
			@Override
			public Outgoing[] getOutgoing() {
				return new Outgoing[] {
					new Outgoing(B.class, none(invokeStat(BInit)))
				};
			}
		}
		
		public class B extends SimpleState {
			@Override
			public Entry onEntry() {
				return new Entry(invokeStat(BEntry));
			}
			
			@Override
			public Exit onExit() {
				return new Exit(invokeStat(BExit));
			}
			
			@Override
			public Do[] onDo() {
				return new Do[] {
					new Do(when(Y, invokeStat(BDo)))
				};
			}
		}
		
		public class Final2 extends FinalState {
			@Override
			public Incoming[] getIncoming() {
				return new Incoming[] {
					new Incoming(B.class, when(F))
				};
			}
		}
		
		public class Init3 extends InitialState {
			@Override
			public Outgoing[] getOutgoing() {
				return new Outgoing[] {
					new Outgoing(C.class, none(invokeStat(CInit)))
				};
			}
		}
		
		public class C extends SimpleState {
			@Override
			public Outgoing[] getOutgoing() {
				return new Outgoing[] {
					new Outgoing(D.class, when(Y, invokeStat(CY)))
				};
			}
		}
		
		public class D extends SimpleState {
			@Override
			public Entry onEntry() {
				return new Entry(invokeStat(DEntry));
			}
			
			@Override
			public Exit onExit() {
				return new Exit(invokeStat(DExit));
			}
			
			@Override
			public Outgoing[] getOutgoing() {
				return new Outgoing[] {
					new Outgoing(A.class, when(Z, invokeStat(DZ)))
				};
			}
		}
		
		public class Final3 extends FinalState {
			@Override
			public Incoming[] getIncoming() {
				return new Incoming[] {
					new Incoming(D.class, when(F))
				};
			}
		}
	}
	
	public class Final1 extends FinalState {
		@Override
		public Incoming[] getIncoming() {
			return new Incoming[] {
				new Incoming(A.class, finalized())
			};
		}
	}
}
