package models.sttt.toy;

import jlx.asal.j.*;
import jlx.blocks.ibd1.*;

public class SimplePcIBD {
	public static class Block extends Type1IBD {
		public final PointPos mem = new PointPos();
		public final InPort<JPulse> s = new InPort<>();
		public final InPort<PointPos> p = new InPort<>();
		public final OutPort<PointPos> m = new OutPort<>();
		public final OutPort<JPulse> d = new OutPort<>();
		public final OutPort<JBool> e = new OutPort<>();
		
		private final PointPos p1 = param("p1", PointPos.class);
		private final PointPos p2 = param("p2", PointPos.class);
		
		public final Operation<JBool> leq = new Operation<JBool>(
			$if(eq(p1, PointPos.L), $return(JBool.TRUE)),
			$if(and(eq(p1, PointPos.M), neq(p2, PointPos.L)), $return(JBool.TRUE)),
			$if(and(eq(p1, PointPos.R), eq(p2, PointPos.R)), $return(JBool.TRUE)),
			$return(JBool.FALSE)
		).withParam(p1).withParam(p2);
		
		public final Operation<JBool> less = new Operation<JBool>(
			$if(and(eq(p1, PointPos.L), neq(p2, PointPos.L)), $return(JBool.TRUE)),
			$if(and(eq(p1, PointPos.M), eq(p2, PointPos.R)), $return(JBool.TRUE)),
			$return(JBool.FALSE)
		).withParam(p1).withParam(p2);
		
		public final Operation<JBool> geq = new Operation<JBool>(seq(
			$return(invoke(leq, p2, p1))
		)).withParam(p1).withParam(p2);
		
		public final Operation<JBool> greater = new Operation<JBool>(seq(
			$return(invoke(less, p2, p1))
		)).withParam(p1).withParam(p2);
	}
}

