package models.sttt.toy;

import jlx.behave.proto.gui.DecaFourSimulatorGUI;
import jlx.common.reflection.ReflectionException;
import jlx.models.*;

public class SimplePcModel {
	private final SimplePcIBD.Block pc;
	private final UnifyingBlock ub;
	
	public SimplePcModel(boolean exploreMIC, boolean exploreSIC) throws ReflectionException {
		Model m = new Model();
		pc = m.add("pc", new SimplePcSMD2());
		
		pc.p.setInitialValue(PointPos.L);
		
		long prevTime = System.currentTimeMillis();
		
		ub = new UnifyingBlock("pc2", m, exploreMIC, exploreSIC);
		
		System.out.println("#time-elapsed = " + (0.001f * (System.currentTimeMillis() - prevTime)) + "s");
	}
	
	public SimplePcIBD.Block get_ibd() {
		return pc;
	}
	
	public UnifyingBlock get_ub() {
		return ub;
	}
	
	public void simulate() {
		new DecaFourSimulatorGUI(ub.sms4);
	}
}

