package models.sttt.toy;

import jlx.asal.j.*;
import jlx.behave.*;

public class SimplePcSMD extends SimplePcIBD.Block implements StateMachine {
	public class Init1 extends InitialState {
		@Override
		public Outgoing[] getOutgoing() {
			return new Outgoing[] {
				new Outgoing(GO_LEFT.class, none(assign(mem, PointPos.L)))
			};
		}
	}
	
	public class GO_LEFT extends SimpleState {
		@Override
		public Entry onEntry() {
			return new Entry(assign(m, PointPos.L));
		}
		
		@Override
		public Do[] onDo() {
			return new Do[] {
				new Do(guard(and(neq(mem, PointPos.L), eq(p, PointPos.L)), assign(mem, PointPos.L), assign(d, JPulse.TRUE))),
				new Do(guard(and(neq(mem, PointPos.L), neq(mem, p)), assign(mem, p))),
			};
		}
		
		@Override
		public Outgoing[] getOutgoing() {
			return new Outgoing[] {
				new Outgoing(GO_RIGHT.class, when(s, and(not(and(eq(mem, PointPos.L), neq(p, PointPos.L))), not(and(eq(mem, PointPos.R), eq(p, PointPos.L)))), $if(and(eq(mem, PointPos.R), eq(p, PointPos.R)), assign(d, JPulse.TRUE))))
			};
		}
	}
	
	public class GO_RIGHT extends SimpleState {
		@Override
		public Entry onEntry() {
			return new Entry(assign(m, PointPos.R));
		}
		
		@Override
		public Do[] onDo() {
			return new Do[] {
				new Do(guard(and(neq(mem, PointPos.R), eq(p, PointPos.R)), assign(mem, PointPos.R), assign(d, JPulse.TRUE))),
				new Do(guard(and(neq(mem, PointPos.R), neq(mem, p)), assign(mem, p))),
			};
		}
		
		@Override
		public Outgoing[] getOutgoing() {
			return new Outgoing[] {
				new Outgoing(GO_LEFT.class, when(s, and(not(and(eq(mem, PointPos.R), neq(p, PointPos.R))), not(and(eq(mem, PointPos.L), eq(p, PointPos.R)))), $if(and(eq(mem, PointPos.L), eq(p, PointPos.L)), assign(d, JPulse.TRUE))))
			};
		}
	}
	
	public class ERROR extends SimpleState {
		@Override
		public Entry onEntry() {
			return new Entry(assign(mem, PointPos.L), assign(m, PointPos.L), assign(e, JBool.TRUE));
		}
		
		@Override
		public Exit onExit() {
			return new Exit(assign(e, JBool.FALSE));
		}
		
		@Override
		public Incoming[] getIncoming() {
			return new Incoming[] {
				new Incoming(GO_LEFT.class, guard(and(eq(mem, PointPos.L), neq(p, PointPos.L)))),
				new Incoming(GO_LEFT.class, guard(and(eq(mem, PointPos.R), eq(p, PointPos.L)))),
				new Incoming(GO_RIGHT.class, guard(and(eq(mem, PointPos.R), neq(p, PointPos.R)))),
				new Incoming(GO_RIGHT.class, guard(and(eq(mem, PointPos.L), eq(p, PointPos.R)))),
			};
		}
		
		@Override
		public Outgoing[] getOutgoing() {
			return new Outgoing[] {
				new Outgoing(GO_LEFT.class, guard(and(eq(p, PointPos.L), eq(s, JPulse.FALSE))))
			};
		}
	}
}
