package models.sttt.toy;

import jlx.asal.j.*;
import jlx.behave.*;

public class SimplePcSMD2 extends SimplePcIBD.Block implements StateMachine {
	public class Init1 extends InitialState {
		@Override
		public Outgoing[] getOutgoing() {
			return new Outgoing[] {
				new Outgoing(GO_LEFT.class, none(assign(mem, PointPos.L)))
			};
		}
	}
	
	public class GO_LEFT extends SimpleState {
		@Override
		public Entry onEntry() {
			return new Entry(assign(m, PointPos.L));
		}
		
		@Override
		public Do[] onDo() {
			return new Do[] {
				new Do(guard(invoke(less, p, mem), assign(mem, p), assign(d, eq(p, PointPos.L)))),
			};
		}
		
		@Override
		public Outgoing[] getOutgoing() {
			return new Outgoing[] {
				new Outgoing(GO_RIGHT.class, when(s, invoke(leq, p, mem), assign(mem, p), assign(d, eq(p, PointPos.R))))
			};
		}
	}
	
	public class GO_RIGHT extends SimpleState {
		@Override
		public Entry onEntry() {
			return new Entry(assign(m, PointPos.R));
		}
		
		@Override
		public Do[] onDo() {
			return new Do[] {
				new Do(guard(invoke(greater, p, mem), assign(mem, p), assign(d, eq(p, PointPos.R)))),
			};
		}
		
		@Override
		public Outgoing[] getOutgoing() {
			return new Outgoing[] {
				new Outgoing(GO_LEFT.class, when(s, invoke(geq, p, mem), assign(mem, p), assign(d, eq(p, PointPos.L))))
			};
		}
	}
	
	public class ERROR extends SimpleState {
		@Override
		public Entry onEntry() {
			return new Entry(assign(mem, PointPos.L), assign(m, PointPos.L), assign(e, JBool.TRUE));
		}
		
		@Override
		public Exit onExit() {
			return new Exit(assign(e, JBool.FALSE));
		}
		
		@Override
		public Incoming[] getIncoming() {
			return new Incoming[] {
				new Incoming(GO_LEFT.class, guard(and(eq(mem, PointPos.R), eq(p, PointPos.L)))),
				new Incoming(GO_LEFT.class, guard(invoke(greater, p, mem))),
				
				new Incoming(GO_RIGHT.class, guard(and(eq(mem, PointPos.L), eq(p, PointPos.R)))),
				new Incoming(GO_RIGHT.class, guard(invoke(less, p, mem))),
			};
		}
		
		@Override
		public Outgoing[] getOutgoing() {
			return new Outgoing[] {
				new Outgoing(GO_LEFT.class, guard(and(eq(p, PointPos.L), eq(s, JPulse.FALSE)), assign(mem, p)))
			};
		}
	}
}
